package Mypackage;

import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import org.eclipse.emf.common.util.BasicEList;
import org.eclipse.emf.common.util.Diagnostic;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.common.util.TreeIterator;
import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EClassifier;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EOperation;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.EValidator;
import org.eclipse.emf.ecore.impl.DynamicEObjectImpl;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.resource.ResourceSet;
import org.eclipse.emf.ecore.resource.URIConverter;
import org.eclipse.emf.ecore.resource.impl.ExtensibleURIConverterImpl;
import org.eclipse.emf.ecore.resource.impl.ResourceSetImpl;
import org.eclipse.emf.ecore.util.Diagnostician;
import org.eclipse.emf.ecore.util.ECrossReferenceEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.ExtendedMetaData;
import org.eclipse.emf.ecore.xmi.impl.XMIResourceFactoryImpl;
import org.eclipse.ocl.common.OCLConstants;
//import org.eclipse.ocl.resour
import org.eclipse.ocl.expressions.OCLExpression;
import org.eclipse.ocl.pivot.Element;
import org.eclipse.ocl.pivot.ElementExtension;
import org.eclipse.ocl.pivot.ExpressionInOCL;
import org.eclipse.ocl.pivot.internal.ClassImpl;
import org.eclipse.ocl.pivot.internal.ElementExtensionImpl;
import org.eclipse.ocl.pivot.internal.delegate.OCLDelegateDomain;
import org.eclipse.ocl.pivot.internal.delegate.OCLInvocationDelegateFactory;
import org.eclipse.ocl.pivot.internal.delegate.OCLSettingDelegateFactory;
import org.eclipse.ocl.pivot.internal.delegate.OCLValidationDelegateFactory;
import org.eclipse.ocl.pivot.internal.manager.MetamodelManagerInternal;
import org.eclipse.ocl.pivot.internal.manager.PivotMetamodelManager;
import org.eclipse.ocl.pivot.internal.utilities.EnvironmentFactoryInternal;
import org.eclipse.ocl.pivot.model.OCLstdlib;
import org.eclipse.ocl.pivot.uml.UMLStandaloneSetup;
import org.eclipse.ocl.pivot.uml.internal.es2as.UML2AS;
import org.eclipse.ocl.pivot.utilities.OCL;
import org.eclipse.ocl.pivot.utilities.OCLHelper;
import org.eclipse.ocl.pivot.utilities.ParserException;
import org.eclipse.ocl.uml.UMLEnvironmentFactory;
import org.eclipse.ocl.uml.util.OCLUMLUtil;
import org.eclipse.ocl.xtext.completeocl.CompleteOCLStandaloneSetup;
import org.eclipse.ocl.xtext.completeocl.CompleteOCLStandaloneSetup;
import org.eclipse.ocl.xtext.essentialocl.EssentialOCLStandaloneSetup;
import org.eclipse.ocl.xtext.oclstdlib.OCLstdlibStandaloneSetup;
import org.eclipse.uml2.uml.Model;
import org.eclipse.uml2.uml.NamedElement;
import org.eclipse.uml2.uml.OpaqueExpression;
import org.eclipse.uml2.uml.Profile;
import org.eclipse.uml2.uml.Stereotype;
import org.eclipse.uml2.uml.UMLPackage;
import org.eclipse.uml2.uml.internal.impl.OpaqueExpressionImpl;
import org.eclipse.uml2.uml.resources.util.UMLResourcesUtil;

import org.eclipse.uml2.uml.Classifier;
import org.eclipse.uml2.uml.Constraint;



public class Ocltest {

	public static void main(String[] args) {
		
		final String input = "NewModels/Domain.uml";
		//final String input = "NewModels/Library.xmi";
		//final String input = "TestGen/TestGen.uml";
		//diagnoticianValidation(input);
		pivotValidation(input);

		
		
	}
	
	private static void diagnoticianValidation(String input)
	{
/*		org.eclipse.ocl.pivot.model.OCLstdlib.install();
		org.eclipse.ocl.pivot.uml.UMLStandaloneSetup.init();
		CompleteOCLStandaloneSetup.doSetup();
		OCLstdlibStandaloneSetup.doSetup();
		EssentialOCLStandaloneSetup.doSetup();
		OCLstdlib.install();*/
		        
		// TODO Auto-generated method stub
		UMLStandaloneSetup.init();
		//CompleteOCLStandaloneSetup.doSetup();
		//OCLstdlibStandaloneSetup.doSetup();
		org.eclipse.ocl.xtext.essentialocl.EssentialOCLStandaloneSetup.doSetup();
		//OCLstdlib.install();
				
        String oclDelegateURI = OCLConstants.OCL_DELEGATE_URI;
        EOperation.Internal.InvocationDelegate.Factory.Registry.INSTANCE.put(oclDelegateURI,
            new OCLInvocationDelegateFactory.Global());
        EStructuralFeature.Internal.SettingDelegate.Factory.Registry.INSTANCE.put(oclDelegateURI,
            new OCLSettingDelegateFactory.Global());
        EValidator.ValidationDelegate.Registry.INSTANCE.put(oclDelegateURI,
            new OCLValidationDelegateFactory.Global());        
        
        System.out.println("Initialization");
        ResourceSet rs = new ResourceSetImpl();
        rs.setURIConverter(new CustomURIConverter());
        
		//OCLDelegateDomain.initialize(rs);
		//UML2AS.initialize(rs);
        
        //org.eclipse.ocl.pivot.model.OCLstdlib.install();
        //org.eclipse.ocl.pivot.uml.UMLStandaloneSetup.init();
        
        OCL ocl = OCL.newInstance(rs);

        System.out.println("Loading UML model " + input);
        Resource resource = ocl.getResourceSet().getResource(createFileURI(input), true);       
		
        Model model = (Model) resource.getContents().get(0);
        //DynamicEObjectImpl model = (DynamicEObjectImpl) resource.getContents().get(0);
        
        //final DynamicEObjectImpl myModel = (DynamicEObjectImpl) model;
        //Resource eresource = resourceSet.getResource(model.eResource().getURI(), true);  
		final TreeIterator<EObject> eoList = model.eAllContents();
		for (EObject eObject : resource.getContents()) {

			System.out.println("Target object: " + eObject);
			
			Diagnostic diagnostic = Diagnostician.INSTANCE.validate(eObject);
			if (diagnostic.getSeverity() != Diagnostic.OK) {
				printDiagnostic(diagnostic, "");
			}
		}
	}
	
	private  static void printDiagnostic(Diagnostic diagnostic, String indent) {
		System.out.print(indent);
		System.out.println(diagnostic.getMessage());
		for (Diagnostic child : diagnostic.getChildren()) {
			printDiagnostic(child, indent + "  ");
		}
	}
	
	private static void pivotValidation(String input)
	{
		// TODO Auto-generated method stub
		UMLStandaloneSetup.init();
		//CompleteOCLStandaloneSetup.doSetup();
		//OCLstdlibStandaloneSetup.doSetup();
		org.eclipse.ocl.xtext.essentialocl.EssentialOCLStandaloneSetup.doSetup();
		//OCLstdlib.install();
				
        
        
        System.out.println("Initialization");
        ResourceSet rs = new ResourceSetImpl();
        rs.setURIConverter(new CustomURIConverter());
        
		//OCLDelegateDomain.initialize(rs);
		//UML2AS.initialize(rs);
        
        //org.eclipse.ocl.pivot.model.OCLstdlib.install();
        //org.eclipse.ocl.pivot.uml.UMLStandaloneSetup.init();
        
        OCL ocl = OCL.newInstance(rs);

        System.out.println("Loading UML model " + input);
        Resource resource = ocl.getResourceSet().getResource(createFileURI(input), true);

        Model uml = (Model)EcoreUtil.getObjectByType(resource.getContents(), UMLPackage.eINSTANCE.getModel());
        //Model uml = (Model) resource.getContents().get(0);
        System.out.println("Root: " + uml);
        
		org.eclipse.ocl.pivot.Model pmodel = null;
		try {
			System.out.println("convert to pivot model test1");
			pmodel = UML2AS.importFromUML((EnvironmentFactoryInternal)ocl.getEnvironmentFactory(), "xx", resource);
			System.out.println("convert to pivot model test12");
		} catch (ParserException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
		
		//Resource emodel = rs.getResource(uml.eResource().getURI(), true);  
		//final EList<EObject> eoList = emodel.getContents();

        EList<Constraint> constraints = new BasicEList<Constraint>(uml.getOwnedRules());

		// Get all OCL rules from the model
		//getOCLRulesFromModel(uml, constraints);
		// Get all OCL rules from the profiles applied to the model
		getOCLRulesFromAppliedProfiles(uml, constraints);
		
		for (Constraint constraint : constraints) {
			
			//System.out.println("UML constraint: "+constraint);
			
			final EList<org.eclipse.uml2.uml.Element> ceList = constraint.getConstrainedElements();
			
			for (org.eclipse.uml2.uml.Element ce : ceList) {
				//System.out.println("Constraint element: "+ce);
				OCLHelper oclHelper = null;

				// stereotypes must be handled specially
				if (ce instanceof Stereotype) {
					// look for all the elements in the model that have the
					// stereotype applied
/*					if(uml.isStereotypeApplied((Stereotype) ce))
					{
						org.eclipse.ocl.pivot.Constraint asConstraint = null;
						org.eclipse.ocl.pivot.ExpressionInOCL asExpression = null;
						try {
							asConstraint = ocl.getMetamodelManager().getASOf(org.eclipse.ocl.pivot.Constraint.class, constraint);
							System.out.println("Pivot constraint: "+asConstraint);
							try {
								asExpression = ocl.getSpecification(asConstraint);
								System.out.println("Pivot constraint Expression:" + asExpression);
							} catch (ParserException e) {
								// TODO Auto-generated catch block
								e.printStackTrace();
							}
						} catch (ParserException e1) {
							// TODO Auto-generated catch block
							e1.printStackTrace();
						}
				
						System.out.println("Validation result: "+ocl.evaluate(uml, asExpression));
						
					}*/
					final EList<org.eclipse.uml2.uml.Element> oeList = uml.allOwnedElements();

					for (org.eclipse.uml2.uml.Element oe : oeList) {
						//System.out.println("Owned element: "+oe);
						if (oe.isStereotypeApplied((Stereotype) ce)) {
							
							org.eclipse.ocl.pivot.Constraint asConstraint = null;
							org.eclipse.ocl.pivot.ExpressionInOCL asExpression = null;
							try {
								asConstraint = ocl.getMetamodelManager().getASOf(org.eclipse.ocl.pivot.Constraint.class, constraint);
								System.out.println("Pivot constraint: "+asConstraint);
								try {
									asExpression = ocl.getSpecification(asConstraint);
									//System.out.println("Pivot constraint Expression:" + asExpression);
								} catch (ParserException e) {
									// TODO Auto-generated catch block
									e.printStackTrace();
								}
							} catch (ParserException e1) {
								// TODO Auto-generated catch block
								e1.printStackTrace();
							}
							System.out.println("Target class: " + oe);
							EObject eo = findTargetObject(oe, resource);
							System.out.println("Validation result: "+ocl.evaluate(eo, asExpression));

/*							org.eclipse.ocl.pivot.Class asClass = null;
							org.eclipse.ocl.pivot.Stereotype asStereotype = null;
							try {

								asClass = ocl.getMetamodelManager().getASOf(org.eclipse.ocl.pivot.Class.class, oe);
								
								System.out.println("Target class: " + asClass);
								asStereotype = ocl.getMetamodelManager().getASOf(org.eclipse.ocl.pivot.Stereotype.class, ce);
								//System.out.println("Check applied stereotype: "+asStereotype);
								//System.out.println("Validation result: "+ocl.check(asClass, asExpression));
								org.eclipse.ocl.pivot.internal.manager.PivotMetamodelManager pmm = (PivotMetamodelManager) ocl.getMetamodelManager();
								ElementExtension ee = pmm.getElementExtension(asClass, asStereotype);
								System.out.println("Validation result: "+ocl.evaluate(ee, asExpression));

						
							} catch (ParserException e) {
								// TODO Auto-generated catch block
								e.printStackTrace();
							}*/
						}
					}
				}
			}
		}
        
		ocl.dispose();		
	}
	
	private static EObject findTargetObject(Object o, Resource resource)
	{
		EObject target = null;
/*		final TreeIterator<EObject> eoList = model.eAllContents();
		while (eoList.hasNext()) {
			EObject eo = eoList.next();
			System.out.println(eo);
		}*/
		for (EObject eo : resource.getContents()) {
			if(eo instanceof DynamicEObjectImpl)
			{
				DynamicEObjectImpl dei = (DynamicEObjectImpl) eo;	
				
				ECrossReferenceEList<EObject> i = (ECrossReferenceEList<EObject>) dei.eCrossReferences();
/*				for(EObject eoo: i)
				{
					if()
				}*/
				if( i.contains(o))
				{
					//System.out.println("Target found: "+eo);
					return eo;
				}

/*				if(dei.dynamicGet(0)!=null)
				{
					if(dei.dynamicGet(0).equals(o))
							return eo;
				}*/
			}
/*
			
			Diagnostic diagnostic = Diagnostician.INSTANCE.validate(eo);
			if (diagnostic.getSeverity() != Diagnostic.OK) {
				return eo;
				//printDiagnostic(diagnostic, "");
			}*/
		}
		
		return target;
	}
	
	
    private static EList<Constraint> getOCLRulesFromAppliedProfiles(Model uml, EList<Constraint> constraints) {
		// TODO Auto-generated method stub
		for (Profile profile : uml.getAllAppliedProfiles()) {

			final TreeIterator<EObject> profileIterator = profile.eAllContents();
			while (profileIterator.hasNext()) {
				EObject tempObject = profileIterator.next();

				if (tempObject instanceof NamedElement) {
					NamedElement ne = (NamedElement) tempObject;

					if (ne.getNamespace() != null) {
						final EList<Constraint> temp = ne.getNamespace().getOwnedRules();

						if (!constraints.containsAll(temp)) {
							constraints.addAll(temp);

						}
					}
				}
			}
		}
		return constraints;		
	}

	private static EList<Constraint> getOCLRulesFromModel(Model uml, EList<Constraint> constraints) {
		// TODO Auto-generated method stub
		final TreeIterator<EObject> iterator = uml.eAllContents();

		while (iterator.hasNext()) {
			EObject tempObject = iterator.next();

			if (tempObject instanceof NamedElement) {
				NamedElement ne = (NamedElement) tempObject;

				if (ne.getNamespace() != null) {
					final EList<Constraint> temp = ne.getNamespace().getOwnedRules();

					if (!constraints.containsAll(temp)) {
						constraints.addAll(temp);
					}
				}
			}
		}
		return constraints;		
	}

	private static URI createFileURI(String relativePath)
    {
        return URI.createFileURI(new File(relativePath).getAbsolutePath());
    }
	
	private static String getOCLExpressionFromConstraint(Constraint constraint) {
		if (constraint.getSpecification() instanceof OpaqueExpression) {
			OpaqueExpression opaqueExpression = ((OpaqueExpression) constraint.getSpecification());

			// Find the body named OCL
			int indexOfOCLBody = -1;
			for (int i = 0; i < opaqueExpression.getLanguages().size() && indexOfOCLBody == -1; i++) {
				if (opaqueExpression.getLanguages().get(i).equals("OCL")) {
					indexOfOCLBody = i;
				}
			}

			// If the body was found, continue the check
			if (indexOfOCLBody != -1) {
				return opaqueExpression.getBodies().get(indexOfOCLBody);
			}
		}
		return null;// there was no proper OCL to be found
	}
	
	private static class CustomURIConverter extends ExtensibleURIConverterImpl implements
    URIConverter {
		@Override
		public InputStream createInputStream(URI uri, Map<?, ?> options)
			throws IOException {
				System.out.println("Loading " + uri);
				return super.createInputStream(uri, options);
		}
	}

}
